<ng-container [ngSwitch]="layout">

    <ng-container *ngSwitchDefault>
        <ng-container *ngTemplateOutlet="default"></ng-container>
    </ng-container>

    <ng-container *ngSwitchCase="'default'">
        <ng-container *ngTemplateOutlet="default"></ng-container>
    </ng-container>

    <ng-container *ngSwitchCase="'widget'">
        <div class="box box-widget widget-user-2">
            <div class="widget-user-header bg-{{type}}" *ngIf="title || header">
                <div class="widget-user-image" *ngIf="image">
                    <img [src]="image" [alt]="title" class="img-circle">
                </div>
                <h3 class="widget-user-username">{{title}}</h3>
                <h5 class="widget-user-desc">{{description}}</h5>
            </div>
            <div class="box-footer" [class.no-padding]="noPadding">
                <ng-container *ngTemplateOutlet="content"></ng-container>
            </div>
        </div>
    </ng-container>

    <ng-container *ngSwitchCase="'small-box'">
        <div class="small-box alert-{{type}}">
            <div class="inner">
                <h3 [innerHTML]="title | safeHtml" *ngIf="title"></h3>
                <p>{{description}}</p>
            </div>
            <div class="icon">
                <i class="{{image}}"></i>
            </div>
            <ng-content select="[boxFooter]"></ng-content>
        </div>
    </ng-container>
</ng-container>

<ng-template #default>
    <div class="box box-{{type}}" [class.collapsed-box]="collapsed">
        <div class="box-header with-border" *ngIf="title || header">
            <h3 class="box-title" *ngIf="title">
                <a routerLink="{{link}}" *ngIf="link else readOnlyTitle">{{title}}</a>
                <ng-template #readOnlyTitle>{{title}}</ng-template>
            </h3>
            <div class="pull-right" *ngIf="!collapsible">
                <ng-content select="[box-header]"></ng-content>
            </div>
            <div class="box-tools pull-right" *ngIf="collapsible">
                <button type="button" class="btn btn-box-tool" data-widget="collapse">
                    <i class="fa" [class.fa-minus]="!collapsed" [class.fa-plus]="collapsed"></i>
                </button>
            </div>
        </div>
        <div class="box-body" [class.no-padding]="noPadding">
            <ng-container *ngTemplateOutlet="content"></ng-container>
        </div>
        <ng-content select="[boxFooter]"></ng-content>
        <div class="overlay" *ngIf="loading">
            <i class="fa fa-circle-o-notch fa-spin"></i>
        </div>
    </div>
</ng-template>

<ng-template #content><ng-content></ng-content></ng-template>